Imports System.IO
Imports System.Runtime.InteropServices
Imports ET199ComLib

Module Module1

    Sub Main()
        Dim et As New ET199

        Try
            Dim nDevCount As Integer
            '(1)ö豸
            System.Console.WriteLine("ö豸...")
            nDevCount = et.Enum()
            If (nDevCount = 0) Then
                Return
            End If
            System.Console.WriteLine(nDevCount.ToString())

            '(2)豸0
            System.Console.WriteLine(vbCrLf & "豸0...")
            et.Open(0)

            DisplayDeviceInfo(et)

            Dim byDevPinDefault(0 To 23) As Byte
            'ʼpinֵ
            Dim i As Integer
            For i = 0 To 23
                byDevPinDefault(i) = 49 + (i Mod 8)
            Next

            Try
                '(3)лĿ¼
                System.Console.WriteLine(vbCrLf & "лĿ¼...")
                et.ChangeDir("\")

                '(4)֤pin
                System.Console.WriteLine(vbCrLf & "֤pin...")
                et.VerifyPin(byDevPinDefault, ET_PIN_TYPE.ET_DEV_PIN)

                '(5)ɾĿ¼
                System.Console.WriteLine(vbCrLf & "ɾĿ¼...")
                et.EraseDir(String.Empty)
            Catch e As COMException
                If e.ErrorCode = ET_ERROR_TYPE.ET_E_DIR_NOT_FOUND Then
                    System.Console.WriteLine("ET199 exception:{0}", et.FormatErrorMessage(e.ErrorCode))
                Else
                    Throw e
                End If
            End Try

            '(6)Ŀ¼
            System.Console.WriteLine(vbCrLf & "Ŀ¼...")
            et.CreateDir("\", 0, ET_DIR_TYPE.ET_ROOT_DIR)

            'ڴĿ¼ǰҪ֤̿
            et.VerifyPin(byDevPinDefault, ET_PIN_TYPE.ET_DEV_PIN)
            '(7)Ŀ¼
            Dim strSubDirID As String
            strSubDirID = "5678"
            System.Console.WriteLine(vbCrLf & "Ŀ¼,IDΪ{0}...", strSubDirID)
            et.CreateDir(strSubDirID, &H2000, ET_DIR_TYPE.ET_SUB_DIR)

            '(8)LED˸
            Dim nLedFreq As Integer
            nLedFreq = 5
            System.Console.WriteLine(vbCrLf & "LED˸ƵΪ{0}...", nLedFreq)
            Dim objLedFreq(0 To 3) As Byte
            objLedFreq(0) = CType(nLedFreq, Byte)
            et.Control(ET_CONTROL_TYPE.ET_LED_WINK, objLedFreq, 4, Nothing, Nothing)

            '(9)Ŀpin
            System.Console.WriteLine(vbCrLf & "Ŀpin...")
            et.ChangePin(byDevPinDefault, byDevPinDefault, ET_PIN_TYPE.ET_DEV_PIN, &HFF)

            '(10)ļ
            Dim strExeFileID As String
            strExeFileID = "1234"
            System.Console.WriteLine(vbCrLf & "һִļ,IDΪ{0}...", strExeFileID)
            et.CreateFile(strExeFileID, &H1000, ET_FILE_TYPE.FILE_TYPE_EXE)

            '(11)дļ
            System.Console.WriteLine(vbCrLf & "дݵִļ{0}...", strExeFileID)
            WriteExeFileData(et, strExeFileID, "..\..\hardware\hardware.bin")

            '(12)֤ûpin
            System.Console.WriteLine(vbCrLf & "֤ûpin...")
            Dim byUserPin(0 To 7) As Byte
            For i = 0 To 7
                byUserPin(i) = 49 + i
            Next
            et.VerifyPin(byUserPin, ET_PIN_TYPE.ET_USER_PIN)

            '(13)пִг
            System.Console.WriteLine(vbCrLf & "пִг{0}", strExeFileID)
            Dim outBuffer(0 To 4) As Byte
            Dim outLen As Integer
            et.Execute(strExeFileID, Nothing, 0, outBuffer, outLen)

            '(14)ȡļϢ
            System.Console.WriteLine(vbCrLf & "ȡļϢ...")
            Dim byFileinfoBuf(0 To 7) As Byte
            byFileinfoBuf(0) = &H31
            byFileinfoBuf(1) = &H32
            byFileinfoBuf(2) = &H33
            byFileinfoBuf(3) = &H34

            Dim nRetlen As New Integer
            et.Control(ET_CONTROL_TYPE.ET_GET_EF_INFO, byFileinfoBuf, 4, byFileinfoBuf, nRetlen)

            '(15)֤pin
            System.Console.WriteLine(vbCrLf & "֤pin...")
            et.VerifyPin(byDevPinDefault, 1)

            '(16)Կ
            System.Console.WriteLine(vbCrLf & "Կ...")
            Dim byPubKeyBuf(0 To 1023) As Byte
            Dim byPriKeyBuf(0 To 1023) As Byte
            et.GenerateRsaKey(1024, &H10001, "1111", "2222", byPubKeyBuf, byPriKeyBuf)

            '(17)лһĿ¼
            System.Console.WriteLine(vbCrLf & "лһĿ¼...")
            et.ChangeDir("..")

            '(18)豸
            System.Console.WriteLine(vbCrLf & "豸...")
            et.Control(ET_CONTROL_TYPE.ET_RESET_DEVICE, Nothing, 0, Nothing, 0)

            '(19)֤pin
            System.Console.WriteLine(vbCrLf & "֤pin...")
            et.VerifyPin(byDevPinDefault, ET_PIN_TYPE.ET_DEV_PIN)

            '(20)ɾĿ¼
            System.Console.WriteLine(vbCrLf & "ɾĿ¼...")
            et.EraseDir(String.Empty)

            '(21)Ŀ¼
            System.Console.WriteLine(vbCrLf & "Ŀ¼...")
            et.CreateDir("\", 0, ET_DIR_TYPE.ET_ROOT_DIR)

            '(22)ر豸
            System.Console.WriteLine(vbCrLf & "ر豸...")
            et.Close()

            System.Console.WriteLine(vbCrLf & "ET199 test end")

        Catch e As COMException
            System.Console.WriteLine("ET199 exception:{0}", et.FormatErrorMessage(e.ErrorCode))
        Catch e As Exception
            System.Console.WriteLine(e.ToString())
        End Try
        System.Console.ReadKey()
    End Sub
    Sub WriteExeFileData(ByVal et As ET199, ByVal strFileID As String, ByVal strFilePath As String)
        Dim fs As FileStream
        fs = File.OpenRead(strFilePath)
        If (fs.Length > 10240) Then
            Throw New Exception("File too large")
        End If
        Dim byDataBuf(fs.Length) As Byte
        fs.Read(byDataBuf, 0, fs.Length)
        Dim buf As Object
        buf = byDataBuf
        et.WriteFile(strFileID, 0, buf, fs.Length)
    End Sub
    Sub DisplayDeviceInfo(ByVal et As ET199)
        'ʾ豸Ϣ

	System.Console.Write("Version:" & vbTab & "{0}.", Int(et.Version / 256))
        System.Console.WriteLine("{0:d02}", et.Version And &HFF)
       
        System.Console.WriteLine("Customer:" & vbTab & "{0:x08}", et.Customer)

        Dim buf() As Byte
        Dim str As String

        buf = CType(et.Atr, Byte())
        str = System.Text.Encoding.ASCII.GetString(buf, 0, buf.Length)
        System.Console.WriteLine("Atr:" & vbTab & vbTab & "{0}", str)

        buf = CType(et.ID, Byte())
        System.Console.WriteLine("ID:" & vbTab & vbTab & "{0:x02}{1:x02}{2:x02}{3:x02}{4:x02}{5:x02}{6:x02}{7:x02}", buf(7), buf(6), buf(5), buf(4), buf(3), buf(2), buf(1), buf(0))
    End Sub

End Module
